#include <stdio.h>
#include <stdlib.h>
#include <String.h>

fpos_t gpos;
fpos_t dpos;

struct rom_info
{
	char name[256];
	unsigned int size;
	unsigned int crc;
	int region;
	int nodump;
};

struct rom_info rom_table[1024];
struct rom_info *romnfo;

struct input_info
{
	char name[64];
	unsigned int value;
	int portnumber;
	int player;
};

struct input_info input_table[1024];
struct input_info *inputnfo;

struct dip_info
{
	char name[256];
	unsigned char value;
	unsigned char mask_value;
	unsigned char def;
	int is_top;
};

struct dip_info dip_table[1024];
struct dip_info *dipnfo;
static int dip_count;

char region_name[1024][256];

FILE *fz, *fk;

char szLine[1024];

unsigned int sscanf0(char *ptr)
{
	unsigned int r = 0;

	int i, s = strlen(ptr);
	for (i = 0; i < s; i++)
	{
		r <<= 4;

		int t = ptr[i];

		if ((t & 0xd0) == 0x40 && (t & 0x0f) < 7 && (t & 0x0f))
			r |= (t & 0x0f) + 9;

		if ((t & 0xf0) == 0x30 && (t & 0x0f) < 0x0a)
			r |= (t & 0x0f);
	}

	return r;
}

#define print_stuff(n, x, tx0, tx1)				\
	inputnfo = &input_table[0]; i = 0;		\
	while (i < 256)		\
	{					\
		if (strncmp (inputnfo->name, n, strlen(n)) == 0 && inputnfo->player == x) { \
			int f = 0;							\
			while (((1 << f) & inputnfo->value) == 0) f++;			\
			input_count++;								\
			fprintf (fk, "\t{\"%s\",\t\tBIT_DIGITAL,	DrvJoy%d + %d,	\"%s\"},\n", tx0, inputnfo->portnumber+1, f, tx1);	\
			break;			\
		}				\
		inputnfo++;i++;			\
	}					\


#define SKIP_ADVANCE_POINTER(n)	\
	while (ptr[0] != n) ptr++; \
	ptr++; \

#define RIP_TEXT(destination, lim0, lim1) \
	{					\
		unsigned char *dst = destination;	\
		while (ptr[0] != lim0 && (unsigned char)ptr[0] != lim1) {	\
			dst[0] = ptr[0];	\
			ptr++;			\
			dst++;			\
		}				\
		dst[0] = '\0';			\
	}

void convert_coin_dip_text(char *input)
{
	char tmp[128];
	char output[128];

	memset (tmp, 0, 128);
	memset (output, 0, 128);

	if ((input[1] == 'C' && input[2] == '_') || (input[2] == 'C' && input[3] == '_'))
	{
		int i, j;
		for (i = 0; i < strlen(input); i++) {
			tmp[i] = input[i];
			if (input[i+1] == 'C') break;
		}
		tmp[i+1] = '\0';

		memcpy (output, tmp, strlen(tmp));

		if (i > 1 || (tmp[0] & 0x0f) > 1) strcat (output, " Coins ");
		else	   strcat (output, " Coin  ");

		for (i = 0; i < strlen(input); i++)
		{
			if (input[i] == '_') {
				for (j = i+1; j < strlen(input); j++)
				{
					tmp[j-(i+1)] = input[j];
					if (input[j+1] == 'C') break;
				}
				break;
			}
		}

		tmp[j-i] = '\0';

		strcat (output, tmp);

		if (i > 1) strcat (output, " Credits");
		else	   strcat (output, " Credit");

		memset (input, 0, 256);
		strcpy (input, output);
	}
	else
		return;
}

void convert_inputs()
{
	char tmp[256];

	char drvname[64];

	int portnum = -1;
	int inside_input = 0;

	int dipcount = 0;
	int countdip = 0;

	int len;

	int prev_was_dip = 0;

	int player_num_enable[4] = {0,0,0,0};

	while (1)
	{
		if (fgets(szLine, 1024, fz) == NULL) break;

		char *ptr = szLine;

		len = strlen(szLine);

		if (len < 2) continue;

		if (strncmp ("static INPUT_PORTS_START(", ptr, strlen("static INPUT_PORTS_START(")) == 0) {
			ptr+= strlen("static INPUT_PORTS_START(");
			while (ptr[0] == ' ') ptr++;

			RIP_TEXT(drvname, ' ', ')')

			dipnfo = &dip_table[0];
			inputnfo = &input_table[0];

			memset (input_table, 0, sizeof (input_table));
			memset (dip_table, 0, sizeof (dip_table));
			memset (rom_table, 0, sizeof(rom_table));

			inside_input = 1;

			portnum = -1;
			memset (player_num_enable, 0, 4*4);
			countdip = 0;
			dipcount = 0;

			continue;
		}

		if (!inside_input) continue;

		while (ptr[0] == '\t' || ptr[0] == ' ') ptr++;

		if (strncmp ("INPUT_PORTS_END", ptr, strlen("INPUT_PORTS_END")) == 0) {
			int i;
			int input_count = 0;

			drvname[0] = toupper(drvname[0]);

			dipcount = 1;
			int previous = 0;
			dipnfo = &dip_table[0];
			while (dipnfo->name[0])
			{
				if (dipnfo->is_top > 0)
				{
					if (dipnfo->mask_value <= previous) {
						dipcount++;
					}
					previous = dipnfo->mask_value;
				}

				dipnfo++;
			}

			fprintf (fk, "static struct BurnInputInfo %sInputList[] = {\n", drvname);

			print_stuff("IPT_COIN1", 0, "P1 Coin", "p1 coin");
			print_stuff("IPT_START1", 0, "P1 Start", "p1 start");
			print_stuff("IPT_JOYSTICK_UP", 0, "P1 Up", "p1 up");
			print_stuff("IPT_JOYSTICK_DOWN", 0, "P1 Down", "p1 down");
			print_stuff("IPT_JOYSTICK_LEFT", 0, "P1 Left", "p1 left");
			print_stuff("IPT_JOYSTICK_RIGHT", 0, "P1 Right", "p1 right");
			print_stuff("IPT_BUTTON1", 0, "P1 Button 1", "p1 fire 1");
			print_stuff("IPT_BUTTON2", 0, "P1 Button 2", "p1 fire 2");
			print_stuff("IPT_BUTTON3", 0, "P1 Button 3", "p1 fire 3");
			print_stuff("IPT_BUTTON4", 0, "P1 Button 4", "p1 fire 4");
			print_stuff("IPT_BUTTON5", 0, "P1 Button 5", "p1 fire 5");
			print_stuff("IPT_BUTTON6", 0, "P1 Button 6", "p1 fire 6");
			print_stuff("IPT_BUTTON7", 0, "P1 Button 7", "p1 fire 7");
			print_stuff("IPT_BUTTON8", 0, "P1 Button 8", "p1 fire 8");
			print_stuff("IPT_BUTTON9", 0, "P1 Button 9", "p1 fire 9");
			print_stuff("IPT_BUTTON10", 0, "P1 Button 10", "p1 fire 10");


#if 1
			print_stuff("IPT_MAHJONG_A", 0, "A", "mah a");
			print_stuff("IPT_MAHJONG_B", 0, "B", "mah b");
			print_stuff("IPT_MAHJONG_C", 0, "C", "mah c");
			print_stuff("IPT_MAHJONG_D", 0, "D", "mah d");
			print_stuff("IPT_MAHJONG_E", 0, "E", "mah e");
			print_stuff("IPT_MAHJONG_F", 0, "F", "mah f");
			print_stuff("IPT_MAHJONG_G", 0, "G", "mah g");
			print_stuff("IPT_MAHJONG_H", 0, "H", "mah h");
			print_stuff("IPT_MAHJONG_I", 0, "I", "mah i");
			print_stuff("IPT_MAHJONG_J", 0, "J", "mah j");
			print_stuff("IPT_MAHJONG_K", 0, "K", "mah k");
			print_stuff("IPT_MAHJONG_L", 0, "L", "mah l");
			print_stuff("IPT_MAHJONG_M", 0, "M", "mah m");
			print_stuff("IPT_MAHJONG_N", 0, "N", "mah n");
			print_stuff("IPT_MAHJONG_PON", 0, "Pon", "mah pon");
			print_stuff("IPT_MAHJONG_CHI", 0, "Chi", "mah chi");
			print_stuff("IPT_MAHJONG_KAN", 0, "Kan", "mah kan");
			print_stuff("IPT_MAHJONG_RON", 0, "Ron", "mah ron");
			print_stuff("IPT_MAHJONG_REACH", 0, "Reach", "mah reach");
			print_stuff("IPT_MAHJONG_FLIP_FLOP", 0, "Flip Flip", "mah ff");
#endif

			if (player_num_enable[1]) {
				fprintf (fk, "\n");
				print_stuff("IPT_COIN2", 0, "P2 Coin", "p2 coin");
				print_stuff("IPT_START2", 0, "P2 Start", "p2 start");
				print_stuff("IPT_JOYSTICK_UP", 1, "P2 Up", "p2 up");
				print_stuff("IPT_JOYSTICK_DOWN", 1, "P2 Down", "p2 down");
				print_stuff("IPT_JOYSTICK_LEFT", 1, "P2 Left", "p2 left");
				print_stuff("IPT_JOYSTICK_RIGHT", 1, "P2 Right", "p2 right");
				print_stuff("IPT_BUTTON1", 1, "P2 Button 1", "p2 fire 1");
				print_stuff("IPT_BUTTON2", 1, "P2 Button 2", "p2 fire 2");
				print_stuff("IPT_BUTTON3", 1, "P2 Button 3", "p2 fire 3");
				print_stuff("IPT_BUTTON4", 1, "P2 Button 4", "p2 fire 4");
				print_stuff("IPT_BUTTON5", 1, "P2 Button 5", "p2 fire 5");
				print_stuff("IPT_BUTTON6", 1, "P2 Button 6", "p2 fire 6");
				print_stuff("IPT_BUTTON7", 0, "P2 Button 7", "p2 fire 7");
				print_stuff("IPT_BUTTON8", 0, "P2 Button 8", "p2 fire 8");
				print_stuff("IPT_BUTTON9", 0, "P2 Button 9", "p2 fire 9");
				print_stuff("IPT_BUTTON10", 0, "P2 Button 10", "p2 fire 10");

#if 1
				print_stuff("IPT_MAHJONG_A", 1, "A", "mah a");
				print_stuff("IPT_MAHJONG_B", 1, "B", "mah b");
				print_stuff("IPT_MAHJONG_C", 1, "C", "mah c");
				print_stuff("IPT_MAHJONG_D", 1, "D", "mah d");
				print_stuff("IPT_MAHJONG_E", 1, "E", "mah e");
				print_stuff("IPT_MAHJONG_F", 1, "F", "mah f");
				print_stuff("IPT_MAHJONG_G", 1, "G", "mah g");
				print_stuff("IPT_MAHJONG_H", 1, "H", "mah h");
				print_stuff("IPT_MAHJONG_I", 1, "I", "mah i");
				print_stuff("IPT_MAHJONG_J", 1, "J", "mah j");
				print_stuff("IPT_MAHJONG_K", 1, "K", "mah k");
				print_stuff("IPT_MAHJONG_L", 1, "L", "mah l");
				print_stuff("IPT_MAHJONG_M", 1, "M", "mah m");
				print_stuff("IPT_MAHJONG_N", 1, "N", "mah n");
				print_stuff("IPT_MAHJONG_PON", 1, "Pon", "mah pon");
				print_stuff("IPT_MAHJONG_CHI", 1, "Chi", "mah chi");
				print_stuff("IPT_MAHJONG_KAN", 1, "Kan", "mah kan");
				print_stuff("IPT_MAHJONG_RON", 1, "Ron", "mah ron");
				print_stuff("IPT_MAHJONG_REACH", 1, "Reach", "mah reach");
				print_stuff("IPT_MAHJONG_FLIP_FLOP", 1, "Flip Flip", "mah ff");
#endif
			}
	
			if (player_num_enable[2]) {
				fprintf (fk, "\n");
	
				print_stuff("IPT_COIN3", 0, "P3 Coin", "p3 coin");
				print_stuff("IPT_START3", 0, "P3 Start", "p3 start");
				print_stuff("IPT_JOYSTICK_UP", 2, "P3 Up", "p3 up");
				print_stuff("IPT_JOYSTICK_DOWN", 2, "P3 Down", "p3 down");
				print_stuff("IPT_JOYSTICK_LEFT", 2, "P3 Left", "p3 left");
				print_stuff("IPT_JOYSTICK_RIGHT", 2, "P3 Right", "p3 right");
				print_stuff("IPT_BUTTON1", 2, "P3 Button 1", "p3 fire 1");
				print_stuff("IPT_BUTTON2", 2, "P3 Button 2", "p3 fire 2");
				print_stuff("IPT_BUTTON3", 2, "P3 Button 3", "p3 fire 3");
				print_stuff("IPT_BUTTON4", 2, "P3 Button 4", "p3 fire 4");
				print_stuff("IPT_BUTTON5", 2, "P3 Button 5", "p3 fire 5");
				print_stuff("IPT_BUTTON6", 2, "P3 Button 6", "p3 fire 6");
				print_stuff("IPT_BUTTON7", 0, "P3 Button 7", "p3 fire 7");
				print_stuff("IPT_BUTTON8", 0, "P3 Button 8", "p3 fire 8");
				print_stuff("IPT_BUTTON9", 0, "P3 Button 9", "p3 fire 9");
				print_stuff("IPT_BUTTON10", 0, "P3 Button 10", "p3 fire 10");

#if 1
				print_stuff("IPT_MAHJONG_A", 2, "A", "mah a");
				print_stuff("IPT_MAHJONG_B", 2, "B", "mah b");
				print_stuff("IPT_MAHJONG_C", 2, "C", "mah c");
				print_stuff("IPT_MAHJONG_D", 2, "D", "mah d");
				print_stuff("IPT_MAHJONG_E", 2, "E", "mah e");
				print_stuff("IPT_MAHJONG_F", 2, "F", "mah f");
				print_stuff("IPT_MAHJONG_G", 2, "G", "mah g");
				print_stuff("IPT_MAHJONG_H", 2, "H", "mah h");
				print_stuff("IPT_MAHJONG_I", 2, "I", "mah i");
				print_stuff("IPT_MAHJONG_J", 2, "J", "mah j");
				print_stuff("IPT_MAHJONG_K", 2, "K", "mah k");
				print_stuff("IPT_MAHJONG_L", 2, "L", "mah l");
				print_stuff("IPT_MAHJONG_M", 2, "M", "mah m");
				print_stuff("IPT_MAHJONG_N", 2, "N", "mah n");
				print_stuff("IPT_MAHJONG_PON", 2, "Pon", "mah pon");
				print_stuff("IPT_MAHJONG_CHI", 2, "Chi", "mah chi");
				print_stuff("IPT_MAHJONG_KAN", 2, "Kan", "mah kan");
				print_stuff("IPT_MAHJONG_RON", 2, "Ron", "mah ron");
				print_stuff("IPT_MAHJONG_REACH", 2, "Reach", "mah reach");
				print_stuff("IPT_MAHJONG_FLIP_FLOP", 2, "Flip Flip", "mah ff");
#endif
			}
	
			if (player_num_enable[3]) {
				fprintf (fk, "\n");
	
				print_stuff("IPT_COIN4", 0, "P4 Coin", "p4 coin");
				print_stuff("IPT_START4", 0, "P4 Start", "p4 start");
				print_stuff("IPT_JOYSTICK_UP", 3, "P4 Up", "p4 up");
				print_stuff("IPT_JOYSTICK_DOWN", 3, "P4 Down", "p4 down");
				print_stuff("IPT_JOYSTICK_LEFT", 3, "P4 Left", "p4 left");
				print_stuff("IPT_JOYSTICK_RIGHT", 3, "P4 Right", "p4 right");
				print_stuff("IPT_BUTTON1", 3, "P4 Button 1", "p4 fire 1");
				print_stuff("IPT_BUTTON2", 3, "P4 Button 2", "p4 fire 2");
				print_stuff("IPT_BUTTON3", 3, "P4 Button 3", "p4 fire 3");
				print_stuff("IPT_BUTTON4", 3, "P4 Button 4", "p4 fire 4");
				print_stuff("IPT_BUTTON5", 3, "P4 Button 5", "p4 fire 5");
				print_stuff("IPT_BUTTON6", 3, "P4 Button 6", "p4 fire 6");
				print_stuff("IPT_BUTTON7", 0, "P4 Button 7", "p4 fire 7");
				print_stuff("IPT_BUTTON8", 0, "P4 Button 8", "p4 fire 8");
				print_stuff("IPT_BUTTON9", 0, "P4 Button 9", "p4 fire 9");
				print_stuff("IPT_BUTTON10", 0, "P4 Button 10", "p4 fire 10");
#if 1
				print_stuff("IPT_MAHJONG_A", 3, "A", "mah a");
				print_stuff("IPT_MAHJONG_B", 3, "B", "mah b");
				print_stuff("IPT_MAHJONG_C", 3, "C", "mah c");
				print_stuff("IPT_MAHJONG_D", 3, "D", "mah d");
				print_stuff("IPT_MAHJONG_E", 3, "E", "mah e");
				print_stuff("IPT_MAHJONG_F", 3, "F", "mah f");
				print_stuff("IPT_MAHJONG_G", 3, "G", "mah g");
				print_stuff("IPT_MAHJONG_H", 3, "H", "mah h");
				print_stuff("IPT_MAHJONG_I", 3, "I", "mah i");
				print_stuff("IPT_MAHJONG_J", 3, "J", "mah j");
				print_stuff("IPT_MAHJONG_K", 3, "K", "mah k");
				print_stuff("IPT_MAHJONG_L", 3, "L", "mah l");
				print_stuff("IPT_MAHJONG_M", 3, "M", "mah m");
				print_stuff("IPT_MAHJONG_N", 3, "N", "mah n");
				print_stuff("IPT_MAHJONG_PON", 3, "Pon", "mah pon");
				print_stuff("IPT_MAHJONG_CHI", 3, "Chi", "mah chi");
				print_stuff("IPT_MAHJONG_KAN", 3, "Kan", "mah kan");
				print_stuff("IPT_MAHJONG_RON", 3, "Ron", "mah ron");
				print_stuff("IPT_MAHJONG_REACH", 3, "Reach", "mah reach");
				print_stuff("IPT_MAHJONG_FLIP_FLOP", 3, "Flip Flip", "mah ff");
#endif
			}

			fprintf (fk, "\n");

			input_count++;
			fprintf (fk, "\t{\"Reset\",\t\tBIT_DIGITAL,	&DrvReset,	\"reset\"},\n");

			print_stuff("IPT_SERVICE1", 0, "Service", "service");
			print_stuff("IPT_SERVICE2", 0, "Service", "service");
			print_stuff("IPT_SERVICE3", 0, "Service", "service");
			print_stuff("IPT_SERVICE4", 0, "Service", "service");
			print_stuff("IPT_SERVICE5", 0, "Service", "service");
			print_stuff("IPT_TILT", 0, "Tilt", "tilt");

			for (i = 0; i < dipcount; i++)
			{
				fprintf (fk, "	{\"Dip %1.1X\",\t\tBIT_DIPSWITCH,\tDrvDip + %d,	\"dip\"},\n", 10+i, i);
			}

			fprintf (fk, "};\n\n");
			fprintf (fk, "STDINPUTINFO(%s)\n\n\n", drvname);

			fprintf (fk, "static struct BurnDIPInfo %sDIPList[]=\n", drvname);
			fprintf (fk, "{\n");
			//fprintf (fk, "	// Default Values\n");

			int counterx = input_count;
			previous = -1;
			unsigned char dmask = 0;
			dipnfo = &dip_table[0];
			while (dipnfo->name[0])
			{
				if (dipnfo->is_top > 0)
				{
					if (dipnfo->mask_value > previous) {
						dmask |= dipnfo->def;
					} else {
						if (previous != -1) {
							fprintf (fk, "\t{0x%2.2x, 0xff, 0xff, 0x%2.2x, NULL\t\t},\n", counterx, dmask);
							counterx++;
						}
						dmask = dipnfo->def;
					}

					previous = dipnfo->mask_value;
				}

				dipnfo++;
			}
			fprintf (fk, "\t{0x%2.2x, 0xff, 0xff, 0x%2.2x, NULL\t\t},\n", counterx, dmask);

			int incount = -1;
			int *topcount = (unsigned int*)malloc(256 * sizeof(int));
			memset (topcount, 0, 256 * sizeof(int));

			dipnfo = &dip_table[0];

			while (dipnfo->name[0])
			{
				if (dipnfo->is_top) {
					incount++;
				}
				else {
					topcount[incount]++;
				}
				dipnfo++;
			}

			incount = -1;
			previous = -1;
			counterx = input_count;
			dipnfo = &dip_table[0];
			while (dipnfo->name[0])
			{
				int i;
				for (i = 0; i < (int)strlen(dipnfo->name); i++) {
					if (dipnfo->name[i] == '_') dipnfo->name[i] = ' ';
				}

				if (dipnfo->is_top == 1) {
					if (dipnfo->mask_value < previous) {
						counterx++;
					}
					previous = dipnfo->mask_value;

					incount++;
					fprintf (fk, "\n\t{0   , 0xfe, 0   ,    %d, \"%s\"\t\t},\n", topcount[incount], dipnfo->name);
				}
				else if (dipnfo->is_top == 0)
				{
					fprintf (fk, "\t{0x%2.2x, 0x01, 0x%2.2x, 0x%2.2x, \"%s\"\t\t},\n", counterx, previous, dipnfo->value, dipnfo->name);
				}

				dipnfo++;
			}

			free (topcount);
			input_count = 0;

			fprintf (fk, "};\n\n");
			fprintf (fk, "STDDIPINFO(%s)\n\n", drvname);

			prev_was_dip = 0;

			inside_input = 0;
		}

		if (strncmp ("PORT_START(", ptr, 11) == 0) {
			portnum ++;
			countdip = 0;
			prev_was_dip = 0;
			continue;
		}

		if (strncmp ("PORT_DIPNAME", ptr, strlen("PORT_DIPNAME")) == 0)
		{
			dipnfo->value = 0;
			dipnfo->is_top = 1;

			ptr += strlen("port_dipname");

			SKIP_ADVANCE_POINTER('x')
	
			RIP_TEXT(tmp, ' ', ',')

			int t = sscanf0(tmp);
			while (t & 0xffffff00) t>>=8;
			dipnfo->mask_value = t;

			SKIP_ADVANCE_POINTER('x')

			RIP_TEXT(tmp, ' ', ',')

			t = sscanf0(tmp);
			while (t & 0xffffff00) t>>=8;
			dipnfo->def = t;

			int defstr = 0;

			while (1)
			{
				if (strncmp ("DEF_STR(", ptr, strlen("DEF_STR(")) == 0)
				{
					defstr = 1;
					ptr += strlen("DEF_STR(");
					break;
				}
				if (ptr[0] == '\"') {
					ptr++;
					break;
				}

				ptr++;
			}
			while (ptr[0] == '\t' || ptr[0] == ' ') ptr++;

			//RIP_TEXT(dipnfo->name, '\"', ')')
			{
				unsigned char *dst = dipnfo->name;
				int t = defstr ? ')' : '\"';
				while (ptr[0] != t) {
					dst[0] = ptr[0];
					ptr++,dst++;
				}
				dst[0] = '\0';
			}

			if (dipnfo->name[strlen(dipnfo->name)-1] == ' ')
				dipnfo->name[strlen(dipnfo->name)-1] = '\0';

			dipnfo++;
			dipnfo->name[0] = 0;

			prev_was_dip = 1;

			continue;
		}

		if (strncmp ("PORT_DIPUNUSED_DIPLOC(", ptr, strlen("PORT_DIPUNUSED_DIPLOC(")) == 0 ||
			strncmp ("PORT_DIPUNUSED(", ptr, strlen("PORT_DIPUNUSED(")) == 0)
		{
			if (strncmp ("PORT_DIPUNUSED(", ptr, strlen("PORT_DIPUNUSED(")) == 0) {
				ptr += strlen("PORT_DIPUNUSED(");
			} else {
				ptr += strlen("PORT_DIPUNUSED_DIPLOC(");
			}

			SKIP_ADVANCE_POINTER('x')

			RIP_TEXT(tmp, ' ', ',')

			int t = sscanf0(tmp);
			while (t & 0xffffff00) t>>=8;

			strcpy (dipnfo->name, "xxxxxxxx");
			dipnfo->mask_value = t;

			int f = 0;
			while (strncmp ("IP_ACTIVE_", ptr + f, strlen("IP_ACTIVE_")) != 0 && (f + 10) <= len)
				f++;

			if (ptr[f] == 'I')
			{
				ptr += strlen("IP_ACTIVE_") + f;

				t = ((ptr[0] == 'L') ? 0xff : 0) & dipnfo->mask_value;
			}
			else
			{
				SKIP_ADVANCE_POINTER('x')

				RIP_TEXT(tmp, ' ', ',')
				t = sscanf0(tmp);
				while (t & 0xffffff00) t>>=8;
			}

			dipnfo->def = t;
			dipnfo->value = t;

			dipnfo->is_top = 2;
			dipnfo++;

			prev_was_dip = 1;

			continue;
		}

		if (strncmp ("PORT_SERVICE_DIPLOC(", ptr, strlen("PORT_SERVICE_DIPLOC(")) == 0 ||
			strncmp ("PORT_SERVICE_NO_TOGGLE(", ptr, strlen("PORT_SERVICE_NO_TOGGLE(")) == 0)
		{
			int type = 0; // 0 no toggle, 1 toggle

			if (ptr[13] == 'N') {
				type = 0;
				strcpy (dipnfo->name, "Service Mode (No Toggle)");
				ptr += strlen("PORT_SERVICE_NO_TOGGLE(");
			} else {
				type = 1;
				strcpy (dipnfo->name, "Service Mode");
				ptr += strlen("PORT_SERVICE_DIPLOC(");
			}

			SKIP_ADVANCE_POINTER('x')

			RIP_TEXT(tmp, ' ', ',')

			int t = sscanf0(tmp);
			while (t & 0xffffff00) t>>=8;
			dipnfo->mask_value = t;

			while (strncmp(ptr, "IP_ACTIVE_", strlen("IP_ACTIVE_")) != 0) ptr++;

			ptr += strlen("IP_ACTIVE_");

			dipnfo->is_top = 1;
			dipnfo->value = 0;

			int x = ((ptr[0] == 'L') ? 0xff : 0) & t;

			dipnfo->def = x;

			dipnfo++;
			strcpy (dipnfo->name, "Off");
			dipnfo->value = x;
			dipnfo->is_top = 0;
			dipnfo->mask_value = 0;

			if (type) {
				dipnfo++;
				strcpy (dipnfo->name, "On");
				dipnfo->value = ~x & t;
				dipnfo->is_top = 0;
				dipnfo->mask_value = 0;
			}

			dipnfo++;
			dipnfo->name[0] = 0;

			prev_was_dip = 1;

			continue;
		}

		if (strncmp ("PORT_DIPSETTING", ptr, strlen("PORT_DIPSETTING")) == 0)
		{
			if (countdip == 0) {
				countdip=1;
				dipcount++;
			}

			dipnfo->mask_value = 0;
			dipnfo->is_top = 0;
			dipnfo->def = 0;

			ptr += strlen("PORT_DIPSETTING");
			SKIP_ADVANCE_POINTER('x')

			RIP_TEXT(tmp, ' ', ',')

			int t = sscanf0(tmp);
			while (t & 0xffffff00) t>>=8;
			dipnfo->value = t;

			int inquote = 0;

			while (1)
			{
				if (strncmp ("DEF_STR(", ptr, strlen("DEF_STR(")) == 0)
				{
					ptr += strlen("def_str(");
					break;
				}
				if (ptr[0] == '\"') {
					inquote = 1;
					ptr++;
					break;
				}

				ptr++;
			}

			while (ptr[0] == ' ' || ptr[0] == '\t') ptr++;

			int i = 0;
			if (inquote)
			{
				while (ptr[0] != '\"') {
					tmp[i] = ptr[0];
					i++,ptr++;
				}
			} else {
				while (ptr[0] != ')'){
					tmp[i] = ptr[0];
					i++,ptr++;
				}
			}

			if (tmp[i-1] == ' ') tmp[i-1] = '\0';
			else tmp[i] = '\0';

			convert_coin_dip_text(tmp);

			strcpy(dipnfo->name, tmp);

			dipnfo++;
			dipnfo->name[0] = 0;

			prev_was_dip = 1;

			continue;
		}

		if (strncmp ("PORT_BIT", ptr, 8) != 0) continue; 

		ptr += 8;

		while (ptr[0] != '0' && ptr[1] == 'x') ptr++;
			ptr+=2;

		RIP_TEXT(tmp, ' ', ',')

		inputnfo->value = sscanf0(tmp);

		int high_low = 0;

		while (ptr[0] == ',' || ptr[0] == ' ') ptr++;
		while (ptr[0] != ',') ptr++; // skip input_active...
		if (ptr[-1] == 'H') high_low = 1;
		while (ptr[0] == ',' || ptr[0] == ' ') ptr++;

		RIP_TEXT(inputnfo->name, ' ', ',')

		ptr = szLine;

		int i = 0;
		while (i < strlen(szLine) - 12)
		{
			if (strncmp("PORT_PLAYER(", ptr, strlen("PORT_PLAYER(")) == 0) {

				ptr += strlen("PORT_PLAYER(");

				ptr[1] = '\0';
				inputnfo->player = sscanf0(ptr)-1;
				player_num_enable[inputnfo->player] = 1;
				break;
			}

			if (strncmp("PORT_COCK", ptr, strlen("PORT_COCK")) == 0) {
				inputnfo->player = 1; // player 2
				player_num_enable[inputnfo->player] = 1;
				break;
			}

			ptr++;
			i++;
		}

		inputnfo->portnumber = portnum;

		if (prev_was_dip) {
			if (strncmp (inputnfo->name, "IPT_UNKNOWN", strlen("IPT_UNKNOWN")) == 0 ||
				strncmp (inputnfo->name, "IPT_UNUSED", strlen("IPT_UNUSED")) == 0) {
				strcpy (dipnfo->name, inputnfo->name);
				dipnfo->mask_value = inputnfo->value;
				dipnfo->def = dipnfo->mask_value; //
				dipnfo->value = ((high_low ? 0 : 0xff) & inputnfo->value);
				dipnfo->is_top = 3;

				dipnfo++;

				prev_was_dip = 1;
			}
		}

		prev_was_dip = 0;

		inputnfo++;
	}
}

int process()
{
	int romregion = 0;
	int indriver = 0;
	int inromcount = 0;
	int inregioncount = 0;

	char romname[128];

	while (1)
	{
		if (fgets(szLine, 1024, fz) == NULL) break;
		if (strncmp ("GAME( ", szLine, 6) == 0) break;
		if (strncmp ("GAMEL( ", szLine, 7) == 0) break;

		if (strncmp ("ROM_START(", szLine, strlen("ROM_START(")) == 0)
		{
			char *ptr = szLine + strlen("ROM_START(");
			while (ptr[0] == ' ') ptr++;

			RIP_TEXT(romname, ' ', ')')

			romregion = 0;
			indriver = 1;
			inromcount = 0;

			memset (rom_table, 0, sizeof (romnfo) * 256);

			romnfo = &rom_table[0];

			continue;
		}

		if (strncmp ("ROM_END", szLine, strlen("ROM_END")) == 0)
		{
			int i;

			int topsizelen = 0;
			int topnamelen = 0;
			romnfo = &rom_table[0];
			for (i = 0; i < inromcount; i++)
			{
				int j,k = romnfo->size;
				for (j = 0; j < 8; j++) {
					if (k == 0) break;
					k >>= 4;
				}

				if (topnamelen < strlen(romnfo->name))
					topnamelen = strlen(romnfo->name);				

				if (j > topsizelen)
					topsizelen = j;

				romnfo++;
			}

			for (i = 0; i < strlen(romname); i++) {
				romname[i] = tolower(romname[i]);
			}

			fgetpos (fz, &dpos);
			fsetpos (fz, &gpos);

			char year[10];
			int decyear = 0;
			char parent[128];
			int isclone = 0;
			char company[256];
			char title[512];
			int isworking = 0;
			char input[64];

			while (1)
			{
				if (fgets (szLine, 1024, fz) == NULL)  break;

				if (strncmp ("GAME", szLine, 4) != 0) continue;

				if (strncmp (romname, szLine + 12, strlen(romname)) != 0) continue;

				char *ptr = szLine;
				while (ptr[0] != '(') ptr++;
				ptr++;

				while (ptr[0] == ' ' || ptr[0] == '\t') ptr++;

				strncpy (year, ptr, 4);
				year[4] = '\0';

				decyear = sscanf0(year);

				ptr += 5;

				while (ptr[0] == ' ' || ptr[0] == '\t') ptr++;

				SKIP_ADVANCE_POINTER(',')

				while (ptr[0] == ' ' || ptr[0] == '\t') ptr++;

				RIP_TEXT(parent, ',', ',')
				ptr++;

				if (strncmp(parent, "0", 1) == 0) {
					isclone = 0;
					parent[0] = '\0';
				} else {
					isclone = 1;
				}

				// past machine init
				SKIP_ADVANCE_POINTER(',')

				// inputs
				while (ptr[0] == ',' || ptr[0] == ' ' || ptr[0] == '\t') ptr++;

				i = 0;
				while (ptr[0] != ' ' && ptr[0] != ',' && ptr[0] != '\t') {
					input[i++] = ptr[0];
					ptr++;
				}
				input[i] = '\0';
				input[0] = toupper(input[0]);

				SKIP_ADVANCE_POINTER(',')  // past game init
				SKIP_ADVANCE_POINTER(',')				
				SKIP_ADVANCE_POINTER(',')  // past rotation (for now)
				SKIP_ADVANCE_POINTER('\"') // get developer

				memset (company, 0, 256);

				RIP_TEXT(company, '\"', '\"')
				ptr++;

				SKIP_ADVANCE_POINTER('\"') // get title

				memset (title, 0, 512);

				RIP_TEXT(title, '\"', '\"')
				ptr++;

				// skip spaces
				while (ptr[0] == ' ' || ptr[0] == ',') ptr++;

				isworking = 1;
				if (ptr[0] == '0') {
					break;
				}

				if (strncmp ("GAME_NOT_WORKING", ptr, strlen("GAME_NOT_WORKING")) == 0) {
					isworking = 0;
					break;
				}

				break;
			}

			fsetpos (fz, &dpos);

			fprintf (fk, "// %s\n\n", title);

			fprintf (fk, "static struct BurnRomInfo %sRomDesc[] = {\n", romname);

			int pregion = -1;
			romnfo = &rom_table[0];
			for (i = 0; i < inromcount; i++)
			{
				if (pregion != romnfo->region) {
					if (pregion != -1) fprintf (fk, "\n");
				}

				if (topnamelen >= 11) {
					if (strlen(romnfo->name) < 11) {
						if (strlen(romnfo->name) < 3) {
							fprintf (fk, "\t{ \"%s\",\t\t\t", romnfo->name);
						} else {
							fprintf (fk, "\t{ \"%s\",\t\t", romnfo->name);
						}
					} else {
						fprintf (fk, "\t{ \"%s\",\t", romnfo->name);
					}
				} else {
					if (strlen(romnfo->name) < 3) {
						fprintf (fk, "\t{ \"%s\",\t\t", romnfo->name, topnamelen);
					} else {
						fprintf (fk, "\t{ \"%s\",\t", romnfo->name, topnamelen);
					}
				}

				switch (topsizelen) {
					case 0:
					case 1:
					case 2:
					case 3:
					case 4:
						fprintf (fk, "0x%4.4x, ", romnfo->size);
					break;

					case 5:
						fprintf (fk, "0x%5.5x, ", romnfo->size);
					break;

					case 6:
						fprintf (fk, "0x%6.6x, ", romnfo->size);
					break;

					case 7:
						fprintf (fk, "0x%7.7x, ", romnfo->size);
					break;
				}

				fprintf (fk, "0x%8.8x, %d", romnfo->crc, romnfo->region+1);
				if (romnfo->crc == 0) fprintf (fk, " | BRF_NODUMP");
				fprintf (fk, " }, // %s%d", (i < 10) ? " " : "", i);

				if (pregion != romnfo->region) {
					fprintf (fk, " %s\n", region_name[romnfo->region]);
				} else {
					fprintf (fk, "\n");
				}

				pregion = romnfo->region;

				romnfo++;
			}

			fprintf (fk, "};\n\n");

			fprintf (fk, "STD_ROM_PICK(%s)\n", romname);
			fprintf (fk, "STD_ROM_FN(%s)\n\n", romname);

			romname[0] = toupper(romname[0]);
			fprintf (fk, "struct BurnDriver BurnDrv%s = {\n", romname);
			romname[0] = tolower(romname[0]);

			fprintf (fk, "\t\"%s\", ", romname);

			if (isclone)
				fprintf (fk, "\"%s\", ", parent);
			else
				fprintf (fk, "NULL, ");

			fprintf (fk, "NULL, NULL, \"%s\",\n", year);
			fprintf (fk, "\t\"%s\\0\", NULL, \"%s\", \"Miscellaneous\",\n", title, company);
			fprintf (fk, "\tNULL, NULL, NULL, NULL,\n");
			if ((isworking | isclone) == 0) {
				fprintf (fk, "\t0, 2, ");
			} else {
				fprintf (fk, "\t%s%s%s, 2, ", (isworking ? "BDF_GAME_WORKING" : ""), ((isworking && isclone) ? " | " : ""), (isclone ? "BDF_CLONE" : ""));
			}

			fprintf (fk, "%s", (decyear < 0x1990) ? "HARDWARE_MISC_PRE90S" : "HARDWARE_MISC_POST90S");
			fprintf (fk, ", GBF_MISC, 0,\n");

			fprintf (fk, "\tNULL, %sRomInfo, %sRomName, NULL, NULL, %sInputInfo, %sDIPInfo,\n", romname, romname, input, input);
			fprintf (fk, "\tDrvInit, DrvExit, DrvFrame, DrvDraw, NULL, &DrvRecalc, 0,\n");
			fprintf (fk, "\t256, 256, 4, 3\n");
			fprintf (fk, "};\n\n\n");

			indriver = 0;
			inromcount = 0;
			romregion = 0;
			inregioncount  = 0;

			continue;
		}

		if (indriver == 0) continue;

	// get rom info

		char *ptr = szLine;

		char name[128];
		char size[128];
		char crc[128];
		unsigned int rsize = 0;
		unsigned int rcrc = 0;

		while (ptr[0] == ' ' || ptr[0] == '\t') ptr++;

		if (strncmp ("ROM_REGION", ptr, strlen("ROM_REGION")) == 0)
		{
			if (inregioncount != 0)	romregion++; // only advance if there are roms in the previous region
				inregioncount = 0;

			ptr += strlen("ROM_REGION");

			SKIP_ADVANCE_POINTER('\"')

			memset (region_name[romregion], 0, 256);

			RIP_TEXT(region_name[romregion], '\"', 0xff)

			continue;
		}

		if (strncmp ("ROM_CONTINUE(", ptr, strlen("ROM_CONTINUE")) == 0)
		{
			char tmp[16];
			ptr += strlen("ROM_CONTINUE");
			int i = 0;
			while (ptr[0] != ',') ptr++;
			SKIP_ADVANCE_POINTER('x')

			RIP_TEXT(tmp, ' ', ')')

			romnfo--;

			romnfo->size += sscanf0(tmp);

			romnfo++;
			continue;
		}

		if (strncmp ("ROM_LOAD", ptr, strlen("ROM_LOAD")) != 0 && 
			strncmp ("ROMX_LOAD", ptr, strlen("ROMX_LOAD")) != 0)
				continue;

		SKIP_ADVANCE_POINTER('\"') // now skip quote

		RIP_TEXT(name, '\"', 0xff)

		strcpy (romnfo->name, name);

		SKIP_ADVANCE_POINTER('x')

		SKIP_ADVANCE_POINTER('x')

		RIP_TEXT(size, ' ', ',')

		rsize = sscanf0(size);
		romnfo->size = rsize;

		while (strncmp ("CRC(", ptr, 4) != 0) {
			if (strncmp("NO_DUMP", ptr, 7) == 0) {
				break;
			}
			ptr++;
		}
		ptr += 4;

		if (ptr[0] != 'U') {
			RIP_TEXT(crc, ' ', ')')
			romnfo->nodump = 0;
		} else {
			romnfo->nodump = 1;
		}

		rcrc = 0;
		if (romnfo->nodump == 0) {
			rcrc = sscanf0(crc);
		}
		romnfo->crc = rcrc;

		romnfo->region = romregion;

		inromcount++;
		romnfo++;
		inregioncount++;

		continue;
	}
}

int main()
{
	char fname[512];

	printf ("Please print the name of the file you wish to process\n");
	gets(fname);

	if (fname[strlen(fname)-1] == '\"') {
		fname[strlen(fname)-1] = '\0';
	}
	if (fname[0] == '\"') {
		strncpy (fname, fname + 1, strlen(fname));
	}

	fz = fopen(fname, "rt");
	fk = fopen("output.cpp", "wt");

	if (fz == NULL) {
		system ("cls");
		printf ("File not found (%s)\n", fname);
		return;
	}

	FILE *fm = fopen("crash", "rb");

	if (fm == NULL)
	{
		unsigned char crash[1] = { 1 };
		fm = fopen("crash", "wb");
		fwrite (crash, 1, 1, fm);
		fclose (fm);

		convert_inputs();
	} else {
		system ("cls");
		printf ("A crash was detected last time you ran this program\n");
		printf ("I am skipping input handling, as it is most likely the\n");
		printf ("cause of the issue.\n");
	}
	fclose (fm);

	rewind(fz);

	while (1)
	{
		if (fgets (szLine, 1024, fz) == NULL)  break;
		if (strncmp ("GAME( ", szLine, 6) == 0) break;
		if (strncmp ("GAMEL( ", szLine, 7) == 0) break;
		fgetpos (fz, &gpos);
	}

	rewind (fz);

	process();

	fclose (fz);
	fclose (fk);

	remove ("crash");

	return 0;
}
